/* loadppm.c
 * compile: gcc -o loadppm loadppm.c
 * Do NOT use -O2 
 *
 * A very simple PPM loader for /dev/grf3
 * Only reads P6 images. Does not overread comments in the P6 header,
 * requires a header like this:
 *
 * P6
 * 512 380
 * 255
 * ...
 *
 * Don't have X running!
 * Copyright 1996, Markus Illenseer, Paderborn, Germany
 * Contact me: markus@tiger.teuto.de
 * 
 *
 */

#include <sys/file.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <amiga/dev/grfioctl.h> 

/* grfioctl.h is normally found in /usr/src/sys/arch/amiga/dev */

#include <stdio.h>
#include <stdlib.h>

void load_image(unsigned char *, struct grfvideo_mode, char *);

int
main(ac,av)
int ac;
char **av;
{
    int grffd, x, y, z;
    int yes = 1, no = 0;
    int vmode = 1;
    struct grfvideo_mode gv;
    unsigned char *fb;
    volatile unsigned char *ba;
    char dummy[10];

    if (ac > 1)
    	vmode = atoi(av[1]);

    if (ac < 3)
     {
      perror("specify: mode ppm-file\n");
      return 0;
     }

    grffd = open("/dev/grf3", O_RDWR);
    if (grffd < 0)
    {
    	perror("loadppm");
    	return(0);
    }
    
    gv.mode_num = vmode;
    ioctl(grffd, GRFGETVMODE, &gv);

    if(gv.depth!=24)
     {
      perror("requires 24Bit");
      return 0;
     }

    fb = mmap(0, 1024*1024*2, PROT_READ|PROT_WRITE, 0, grffd, 65536);
    if ((int)fb < 0)
    {
    	perror("loadppm mmap");
    	return(0);
    }
    ba = mmap(0, 65536, PROT_READ|PROT_WRITE, 0, grffd, 0);

    ioctl(grffd, GRFSETVMODE, &vmode);
    ioctl(grffd, GRFIOCON, &yes);

    load_image(fb,gv,av[2]);
    fgets(dummy, 4, stdin);

    munmap(fb, 1024*1024*2);
    munmap(ba, 65536);

    ioctl(grffd, GRFIOCOFF, &no);
    close(grffd);


    return(0);
}

void load_image(unsigned char *fb, struct grfvideo_mode gv, char *name)
{
 int file;
 int y;
 int s,z;
 int width, height;
 char buffer[15];

 /* clear */

 memset(fb,0,(gv.disp_height * gv.disp_width * 3));

 file = open(name,O_RDWR);
 
 read(file, buffer, 3);
 read(file, buffer, 3);
 width=atoi(buffer);

 read(file, buffer, 1);
 read(file, buffer, 3);
 height=atoi(buffer); 
 read(file, buffer, 4);

 /* Optimizer will bust here! */

 for(y=0; y<height; y++)
  read(file, fb+(y*3*gv.disp_width),width*3);

 /* No idea how to perform a *fast* bgr to rgb conversion, so I leave
    that to you :-)
 */
 
 close(file);
}
